package deployment

import (
	"github.com/ankitrgadiya/operatorlib/pkg/container"
	"github.com/ankitrgadiya/operatorlib/pkg/interfaces"
	"github.com/ankitrgadiya/operatorlib/pkg/meta"
	"github.com/ankitrgadiya/operatorlib/pkg/pod"

	appsv1 "k8s.io/api/apps/v1"
	"k8s.io/apimachinery/pkg/runtime"
)

// GenConfigMapFunc defines a function which generates ConfigMap.
type GenDeploymentFunc func(Conf) (*appsv1.Deployment, error)

// Conf is used to pass parameters to functions in this package to
// perform operations on Configmap objects.
type Conf struct {
	//	Meta     meta.Mutate
	//	Pod            pod.Mutate
	Obj            *appsv1.Deployment
	Reconcile      interfaces.Reconcile
	previousObject runtime.Object

	Owner          interfaces.Object
	Namespace      string
	Name           string
	OwnerReference bool
	GenFinalizers  meta.GenFinalizers
	GenLabels      meta.GenLabels
	GenAnnotations meta.GenAnnotations

	Strategy appsv1.DeploymentStrategy

	GenDeploymentFunc

	GenContainers []container.Mutate

	// Pod                    pod.Mutate

	GenVolumesFunc         pod.GenVolumesFunc
	GenSecurityContextFunc pod.GenSecurityContextFunc
	GenRestartPolicyFunc   pod.GenRestartPolicyFunc
}
